/*
	Copyright (c) 1993 by Robert Jervis
	All rights reserved.

	Permission to use, copy, modify and distribute this software is
	subject to the license described in the READ.ME file.
 */
include	error;
include	file;
include	editor;
include	alys;
include	filesys;
include	environ;
include	window;

mainSetup:	entry	() =
	{
	fname:	[:] char;

//	catchSignal(SigBreak, &breakKey);
	if	(ArgumentCount == 0){
		printf("ED Version 0.87 use is: ED filename[s]\n");
		exit(0);
		}
	fname = getNextArgument();

	MainMenu submenu("File", &FileMenu);
	MainMenu submenu("Edit", &EditMenu);
	MainMenu submenu("Options", &OptionMenu);

	FileMenu button("Read File         F3", &startSession);
	FileMenu button("Save File         F2", &saveSession);
	FileMenu button("Change Name",          &renameSession);
	FileMenu button("OS-Shell", 	    &shellToDos);
	FileMenu button("Quit           Alt-X", &shutDownViewers);

	EditMenu button("Search      Alt-S", &searchButton);
	EditMenu button("Replace     Alt-Q", &replaceButton);
	EditMenu button("Last Again  Alt-L", &againButton);
	EditMenu button("Goto Line   Alt-G", &gotoLine);

	OptionMenu button("Regular Expressions", &toggleRegularExpression);

	for	(;;){
		beginSession(fname, &MainMenu);
		if	(ArgumentCount == 0)
			break;
		fname = getNextArgument();
		}

	GlobalMap defineFunction("editfile", "Open file editor",  &startSession, F3);

	FileEditMap defineFunction("nextview", "Go to next viewer", &nextViewer, F6);
	FileEditMap defineFunction("gotoline", "Go to line", &gotoLine, ALT_G);

	consoleInput();
	}
/*
breakKey:	interrupt (ifr: interruptFrame) =
	{
	catchSignal(SigBreak, &breakKey);
	setSignalThreshold(ifr.threshold);
	}
 */
MainMenu:	menu;
EditMenu:	menu;
FileMenu:	menu;
OptionMenu:	menu;

searchButton:	(v: * viewer) =
	{
	v search();
	}

replaceButton:	(v: * viewer) =
	{
	v replace();
	}

againButton:	(v: * viewer) =
	{
	v again();
	}

shellToDos:	(* viewer) =
	{
	cmd:	[MAXPATH] char;
	cmds:	[:] char;
	p:	ref far external;

	cmds = cmd;
	cmds [:]= Environment get("COMSPEC");
	p = Host spawn(cmds, "");
	if	(p == 0)
		postMessage("Failed to execute");
	}
